part of trober_sdk.api;

// DeviceId
class DeviceId {
  String token;
  DeviceId();

  @override
  String toString() {
    return 'DeviceId[token=$token, ]';
  }

  fromJson(Map<String, dynamic> json) {
    if (json == null) return;

    {
      final _jsonData = json[r'token'];
      token = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
  }

  DeviceId.fromJson(Map<String, dynamic> json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    if (token != null) {
      json[r'token'] = LocalApiClient.serialize(token);
    }
    return json;
  }

  static List<DeviceId> listFromJson(List<dynamic> json) {
    return json == null
        ? <DeviceId>[]
        : json.map((value) => DeviceId.fromJson(value)).toList();
  }

  static Map<String, DeviceId> mapFromJson(Map<String, dynamic> json) {
    final map = <String, DeviceId>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = DeviceId.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is DeviceId && runtimeType == other.runtimeType) {
      return token == other.token;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    if (token != null) {
      hashCode = hashCode ^ token.hashCode;
    }

    return hashCode;
  }

  DeviceId copyWith({
    String token,
  }) {
    DeviceId copy = DeviceId();
    copy.token = token ?? this.token;
    return copy;
  }
}
